<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'GetVersionRs' => '\\StructType\\GetVersionRs',
            'IsPostalCodeValidRq' => '\\StructType\\IsPostalCodeValidRq',
            'IsPostalCodeValidRs' => '\\StructType\\IsPostalCodeValidRs',
            'RateShipmentAllServicesRq' => '\\StructType\\RateShipmentAllServicesRq',
            'RateShipmentAllServicesRs' => '\\StructType\\RateShipmentAllServicesRs',
            'RateShipmentAllPremiumsRq' => '\\StructType\\RateShipmentAllPremiumsRq',
            'RateShipmentAllPremiumsRs' => '\\StructType\\RateShipmentAllPremiumsRs',
            'GetAvailableServicesRq' => '\\StructType\\GetAvailableServicesRq',
            'GetAvailableServicesRs' => '\\StructType\\GetAvailableServicesRs',
            'IsAlternativeServiceRq' => '\\StructType\\IsAlternativeServiceRq',
            'IsAlternativeServiceRs' => '\\StructType\\IsAlternativeServiceRs',
            'GetProfileRq' => '\\StructType\\GetProfileRq',
            'GetProfileRs' => '\\StructType\\GetProfileRs',
            'SubmitManifestRq' => '\\StructType\\SubmitManifestRq',
            'SubmitManifestRs' => '\\StructType\\SubmitManifestRs',
            'SubmitFileRq' => '\\StructType\\SubmitFileRq',
            'SubmitFileRs' => '\\StructType\\SubmitFileRs',
            'IsResidentialRq' => '\\StructType\\IsResidentialRq',
            'IsResidentialRs' => '\\StructType\\IsResidentialRs',
            'GetProfilesRq' => '\\StructType\\GetProfilesRq',
            'GetProfilesRs' => '\\StructType\\GetProfilesRs',
            'RateShipmentRq' => '\\StructType\\RateShipmentRq',
            'RateShipmentRs' => '\\StructType\\RateShipmentRs',
            'SearchCanadaPostRq' => '\\StructType\\SearchCanadaPostRq',
            'SearchCanadaPostRs' => '\\StructType\\SearchCanadaPostRs',
            'Shipment' => '\\StructType\\Shipment',
            'Address' => '\\StructType\\Address',
            'Package' => '\\StructType\\Package',
            'COD' => '\\StructType\\COD',
            'Proforma' => '\\StructType\\Proforma',
            'ProformaItem' => '\\StructType\\ProformaItem',
            'CommodityInfo' => '\\StructType\\CommodityInfo',
            'ProcessShipmentResult' => '\\StructType\\ProcessShipmentResult',
            'GetAvailableServicesResult' => '\\StructType\\GetAvailableServicesResult',
            'Profile' => '\\StructType\\Profile',
            'Service' => '\\StructType\\Service',
            'getVersionResponse' => '\\StructType\\GetVersionResponse',
            'isPostalCodeValid' => '\\StructType\\IsPostalCodeValid',
            'isPostalCodeValidResponse' => '\\StructType\\IsPostalCodeValidResponse',
            'rateShipmentAllServices' => '\\StructType\\RateShipmentAllServices',
            'rateShipmentAllServicesResponse' => '\\StructType\\RateShipmentAllServicesResponse',
            'rateShipmentAllPremiums' => '\\StructType\\RateShipmentAllPremiums',
            'rateShipmentAllPremiumsResponse' => '\\StructType\\RateShipmentAllPremiumsResponse',
            'getAvailableServices' => '\\StructType\\GetAvailableServices',
            'getAvailableServicesResponse' => '\\StructType\\GetAvailableServicesResponse',
            'isAlternativeService' => '\\StructType\\IsAlternativeService',
            'isAlternativeServiceResponse' => '\\StructType\\IsAlternativeServiceResponse',
            'getProfile' => '\\StructType\\GetProfile',
            'getProfileResponse' => '\\StructType\\GetProfileResponse',
            'submitManifest' => '\\StructType\\SubmitManifest',
            'submitManifestResponse' => '\\StructType\\SubmitManifestResponse',
            'submitFile' => '\\StructType\\SubmitFile',
            'submitFileResponse' => '\\StructType\\SubmitFileResponse',
            'isResidential' => '\\StructType\\IsResidential',
            'isResidentialResponse' => '\\StructType\\IsResidentialResponse',
            'getProfiles' => '\\StructType\\GetProfiles',
            'getProfilesResponse' => '\\StructType\\GetProfilesResponse',
            'rateShipment' => '\\StructType\\RateShipment',
            'rateShipmentResponse' => '\\StructType\\RateShipmentResponse',
            'searchCanadaPost' => '\\StructType\\SearchCanadaPost',
            'searchCanadaPostResponse' => '\\StructType\\SearchCanadaPostResponse',
        );
    }
}
