<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RateShipmentRs StructType
 * @subpackage Structs
 */
class RateShipmentRs extends AbstractStructBase
{
    /**
     * The error
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $error;
    /**
     * The processShipmentResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProcessShipmentResult
     */
    public $processShipmentResult;
    /**
     * Constructor method for RateShipmentRs
     * @uses RateShipmentRs::setError()
     * @uses RateShipmentRs::setProcessShipmentResult()
     * @param string $error
     * @param \StructType\ProcessShipmentResult $processShipmentResult
     */
    public function __construct($error = null, \StructType\ProcessShipmentResult $processShipmentResult = null)
    {
        $this
            ->setError($error)
            ->setProcessShipmentResult($processShipmentResult);
    }
    /**
     * Get error value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getError()
    {
        return isset($this->error) ? $this->error : null;
    }
    /**
     * Set error value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $error
     * @return \StructType\RateShipmentRs
     */
    public function setError($error = null)
    {
        // validation for constraint: string
        if (!is_null($error) && !is_string($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        if (is_null($error) || (is_array($error) && empty($error))) {
            unset($this->error);
        } else {
            $this->error = $error;
        }
        return $this;
    }
    /**
     * Get processShipmentResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProcessShipmentResult|null
     */
    public function getProcessShipmentResult()
    {
        return isset($this->processShipmentResult) ? $this->processShipmentResult : null;
    }
    /**
     * Set processShipmentResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\ProcessShipmentResult $processShipmentResult
     * @return \StructType\RateShipmentRs
     */
    public function setProcessShipmentResult(\StructType\ProcessShipmentResult $processShipmentResult = null)
    {
        if (is_null($processShipmentResult) || (is_array($processShipmentResult) && empty($processShipmentResult))) {
            unset($this->processShipmentResult);
        } else {
            $this->processShipmentResult = $processShipmentResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RateShipmentRs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
